// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

#[cfg(feature = "v3_30")]
#[cfg_attr(docsrs, doc(cfg(feature = "v3_30")))]
use glib::{prelude::*, translate::*};
use std::fmt;

glib::wrapper! {
    #[doc(alias = "DzlReadOnlyListModel")]
    pub struct ReadOnlyListModel(Object<ffi::DzlReadOnlyListModel, ffi::DzlReadOnlyListModelClass>) @implements gio::ListModel;

    match fn {
        type_ => || ffi::dzl_read_only_list_model_get_type(),
    }
}

impl ReadOnlyListModel {
    #[cfg(feature = "v3_30")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_30")))]
    #[doc(alias = "dzl_read_only_list_model_new")]
    pub fn new(base_model: &impl IsA<gio::ListModel>) -> Option<gio::ListModel> {
        assert_initialized_main_thread!();
        unsafe {
            from_glib_full(ffi::dzl_read_only_list_model_new(
                base_model.as_ref().to_glib_none().0,
            ))
        }
    }
}

impl fmt::Display for ReadOnlyListModel {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("ReadOnlyListModel")
    }
}
